
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

#include  <sndfile.h>

#include  "pokesound.h"

/* ----------------------------------------------------------------- */
/* Sun Aug 27 16:51:31 UTC 2023

*/

int poke_un_fragment(SndPk_sndbuff *src, SndPk_sndbuff *dst, float start)
{
int		startpos, idx, taille, dispo;
short		*pa, *pb;

fprintf(stderr, ">>> %s ( %p %p %.3f )\n", __func__, src, dst, start);

/*
 *	please, add molly-guard !
 */
taille = src->nbframes;
fprintf(stderr, "    nbframes source   %d, ", taille);

startpos = (int)(dst->samplerate * start) * 2;
fprintf(stderr, " startpos  %d, ", startpos);
dispo = dst->nbframes - startpos;
fprintf(stderr, " disponible  %d\n", dispo);

pa = (short *)src->datas;
pb = ((short *)dst->datas) + startpos;

for (idx=0; idx<src->nbframes; idx++) {
	// fprintf(stderr, "%7d / %7d\n", idx, src->nbframes);

	/* ONLY FOR STEREO BUFFERS ! */
	*pb++ = *pa++;
	*pb++ = *pa++;
	}

return 0;
}
/* ----------------------------------------------------------------- */
